import numpy as np
from edgeiq._production_client import PRODUCTION_CLIENT as PRODUCTION_CLIENT
from edgeiq.engine_accelerator import Accelerator as Accelerator, Engine as Engine
from edgeiq.object_detection import ObjectDetection as ObjectDetection, ObjectDetectionResults as ObjectDetectionResults
from edgeiq.tools.image_manipulation import convert_to_jpg as convert_to_jpg
from typing import Any

class ObjectDetectionHttpClient(ObjectDetection):
    def __init__(self, model_id: str, server_url: str) -> None: ...
    def load(self, engine: Engine = ..., accelerator: Accelerator = ...): ...
    def detect_objects(self, image: np.ndarray, confidence_level: float = 0.3, overlap_threshold: float = 0.3) -> ObjectDetectionResults: ...
    def detect_objects_batch(self, images: list[np.ndarray], confidence_level: float = 0.3, overlap_threshold: float = 0.3) -> list[ObjectDetectionResults]: ...
    def publish_analytics(self, results: ObjectDetectionResults, tag: Any = None): ...
