import numpy as np
from .model import validate_model as validate_model
from _typeshed import Incomplete
from edgeiq import _constants

def is_python_equal_greater_than38(): ...

SUPPORTED_FRAMEWORKS: Incomplete
DNN_SUPPORTED_FRAMEWORKS: Incomplete
CUDA_SUPPORTED_FRAMEWORKS: Incomplete
HAILO_SUPPORTED_FRAMEWORKS: Incomplete
TENSOR_RT_SUPPORTED_FRAMEWORKS: Incomplete
TENSOR_RT_SUPPORTED_PURPOSES: Incomplete
QAIC_SUPPORTED_FRAMEWORKS: Incomplete
ONNX_SUPPORTED_FRAMEWORKS: Incomplete
SUPPORTED_PURPOSES: Incomplete

def is_supported_purpose(purpose): ...
def is_supported_framework_type(framework): ...
def is_supported_device(device): ...
def load_model_json(model_json_path) -> dict: ...
def load_labels(label_file_path: str | None, model_path: str) -> list[str] | None: ...
def load_colors(color_file_path: str | None, colors_dtype, num_labels: int, model_path: str) -> np.ndarray: ...
def get_colors_dtype(purpose): ...

MODEL_CONFIG_SCHEMA: Incomplete

def validate_model_cfg(model_path: str, model_cfg: dict): ...

class ModelConfig:
    def __init__(self, model_json: dict, base_dir: str | None = None, labels: list[str] | None = None, colors: np.ndarray | None = None) -> None: ...
    @classmethod
    def from_model_id(cls, model_id: str) -> ModelConfig: ...
    def __eq__(self, other): ...
    @property
    def config(self) -> dict: ...
    @property
    def model_parameters(self) -> dict: ...
    @property
    def id(self) -> str: ...
    @id.setter
    def id(self, id: str): ...
    @property
    def label_file(self) -> str | None: ...
    @property
    def colors_file(self) -> str | None: ...
    @property
    def model_file(self) -> str: ...
    @property
    def config_file(self) -> str | None: ...
    @property
    def mean(self) -> tuple[float, float, float]: ...
    @property
    def scalefactor(self) -> float: ...
    @property
    def size(self) -> tuple[int, int]: ...
    @property
    def purpose(self) -> str: ...
    @property
    def framework_type(self) -> str: ...
    @framework_type.setter
    def framework_type(self, framework_type: str): ...
    @property
    def crop(self) -> bool: ...
    @property
    def colors_dtype(self) -> str: ...
    @property
    def labels(self) -> list[str] | None: ...
    @property
    def colors(self) -> np.ndarray | None: ...
    @colors.setter
    def colors(self, colors: list[tuple[int, int, int]]): ...
    @property
    def swaprb(self) -> bool: ...
    @property
    def architecture(self) -> str | None: ...
    @property
    def softmax(self) -> bool: ...
    @property
    def device(self) -> _constants.SupportedDevices | None: ...
    @property
    def output_layer_names(self) -> list[str] | None: ...
    @property
    def hailo_quantize_input(self) -> bool | None: ...
    @property
    def hailo_quantize_output(self) -> bool | None: ...
    @property
    def hailo_input_format(self) -> str | None: ...
    @property
    def hailo_output_format(self) -> str | None: ...
    @property
    def dnn_support(self) -> bool: ...
    @property
    def dnn_cuda_support(self) -> bool: ...
    @property
    def tensor_rt_support(self) -> bool: ...
    @property
    def hailo_support(self) -> bool: ...
    @property
    def qaic_support(self) -> bool: ...
    @property
    def onnx_rt_support(self) -> bool: ...
    @property
    def batch_size(self) -> int: ...
